new;
library gdr,pgraph;
gdrSet;

load RiskReturn = cpm41;
RiskReturn[.,2] = RiskReturn[.,2] ./ 1e4;

Risk0 = RiskReturn[1,1];
exReturn0 = RiskReturn[1,2];
Risk = RiskReturn[.,1]; 
exReturn = RiskReturn[.,2];

indx_ch = ConvexHull(RiskReturn[.,2 1]);
ch = RiskReturn[indx_ch,.];

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plctrl = -1; _psymsiz = 0.5; _pstype = 4;
  _psym = Risk0~exReturn0~11~5~12~1~0;
  plineConnectPoints(ch[4 5 6 7 8 9 10 1,.]);  
  xy(Risk,exReturn);

indx = 4|5|6|7|8|9|10|1;
indx_ch = indx_ch[indx];
ch = ch[indx,.];

save convex-hull = ch;

y_min = minc(ch[.,2]);
y_max = maxc(ch[.,2]);
y = seqa(y_min,(y_max-y_min)/100,101);
x = fspline(csspline(ch[.,2],ch[.,1],1,1),y);

graphset;
  fonts("simplex simgrma");
  _pcolor = 10;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plctrl = -1; _psymsiz = 2.5; _pstype = 4;
  _psym = Risk0~ExReturn0~11~5~12~1~0 |
          ch[.,1]~ch[.,2]~ones(rows(ch),1).*(8~4~9~1~0);
  plineConnectPoints(x~y);
  xlabel("\216VaR");
  ylabel("\216Rendement");
  xtics(0.9e5,1.05e5,0.05e5,5);
  ytics(3.8e4,4.10e4,0.05e4,5);
  _pmsgstr = "Portefeuille original\000Frontiere efficiente";
  _pmsgctl = 1.002*Risk0~exReturn0~0.175~0~1~0~10 | 
             0.94e5~3.94e4~0.175~30~1~0~10;
  _pmsgstr = _pmsgstr $+ "\000\201`";
  _pmsgctl = _pmsgctl | 3.88~4.03~0.18~70~2~0~6;
  graphprt("-c=1 -cf=cpm43.ps");
  xy(Risk,exReturn);
