new;
library gdr,pgraph,co;
gdrSet;

external matrix _localQuantile_weight;
declare matrix _Deriv;

fileName = "portfolio-1";
load data = ^fileName;
EaD = data[.,3];
Spread1Y = data[.,7];
rating = data[.,8];
let mulSpread = 2 1.9 1.8 1.7 1.5 1.4 1.2;
Spread = Spread1Y .* recode(rating, rating .== seqa(1,1,7)', mulSpread); 
Euribor = 500;
Spread = (Euribor + Spread) / 1e4;
ExReturn0 = sumc(EaD .* Spread);

fileName = "cpm2";
datName = fileName $+ "-cpm-portfolio-loss";
cpmLoss = loadd(datName);
datName = fileName $+ "-cpm-loan-loss";
loans = seqa(1,20,25);
cpmLoans = loadd(datName)';
nLoans = rows(loans);
X0 = EaD[Loans];
LoanSpread = Spread[loans];
LoanReturn = sumc(X0 .* LoanSpread);

_RiskMeasure = 1;
alpha = 0.999;
_localQuantile_Bandwidth = 50;
_localQuantile_mtd = 2;
{VaR0,DR0,cRC0} = CreditVaR_RiskContribution(fileName,alpha);

proc (3) = VaR_and_DR(X);
  local Li,L,VaR,indx,p,cRc,DR;

  Li = X .* cpmLoans ./ X0;
  L = cpmLoss + sumc(Li);
  VaR = localQuantile(L,alpha);
  indx = _localQuantile_weight[.,1];
  p = _localQuantile_weight[.,2];
 
  cRC = sumc( p .* Li[.,indx]');
  DR = cRC ./ X;

  retp(VaR,DR,cRC);
endp;

proc (1) = MinVaR(X);
  local VaR,DR,cRC;

  {VaR,DR,cRC} = VaR_and_DR(X);
   _Deriv = DR;

  retp( VaR );
endp;

fn GradVaR(X) = _Deriv;

_CO_A = ones(1,25);
_CO_B = 25000;
_co_Bounds = {0 25000};
_CO_C = LoanSpread';

_co_Algorithm = 3;
_co_GradProc = &GradVaR;
_co_DirTol = 1e-10;

target = 39000;
_co_D = target-(ExReturn0-LoanReturn);

sv = rndu(25,1);
sv = sv * 25000 / sumc(sv);

{x,f,g,retcode} = co(&MinVaR,x0);
save cpm45 = x;

load x = cpm45;

Risk_X = MinVaR(X);
Li = X .* cpmLoans ./ X0;
L = cpmLoss + sumc(Li);
Risk_X = quantile(L,alpha);
ExReturn_X = x'LoanSpread + (ExReturn0-LoanReturn);

load RiskReturn = cpm41;
RiskReturn[.,2] = RiskReturn[.,2] ./ 1e4;

Risk0 = RiskReturn[1,1];
exReturn0 = RiskReturn[1,2];
Risk = RiskReturn[.,1]; 
exReturn = RiskReturn[.,2];

load ch = convex-hull;

y_min = minc(ch[.,2]);
y_max = maxc(ch[.,2]);
y = seqa(y_min,(y_max-y_min)/100,101);
x = fspline(csspline(ch[.,2],ch[.,1],1,1),y);

graphset;
  fonts("simplex simgrma");
  _pcolor = 10;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _plctrl = -1; _psymsiz = 2.5; _pstype = 4;
  _psym = Risk0~ExReturn0~11~5~12~1~0 |
          ch[.,1]~ch[.,2]~ones(rows(ch),1).*(8~4~9~1~0) |
          Risk_X~ExReturn_X~11~5~12~1~0 ;
  plineConnectPoints(x~y);
  xlabel("\216VaR");
  ylabel("\216Rendement");
  xtics(0.9e5,1.05e5,0.05e5,5);
  ytics(3.8e4,4.10e4,0.05e4,5);
  _pmsgstr = "Portefeuille original\000Frontiere efficiente\000Portefeuille optimise";
  _pmsgctl = 1.002*Risk0~exReturn0~0.165~0~1~12~10 | 
             0.94e5~3.94e4~0.175~30~1~0~10 |
             1.002*Risk_X~exReturn_X~0.165~0~1~12~10;
  _pmsgstr = _pmsgstr $+ "\000\201`";
  _pmsgctl = _pmsgctl | 3.88~4.03~0.18~70~2~0~6;
  _pmsgstr = _pmsgstr $+ "\000\202\39\201";
  _pmsgctl = _pmsgctl | 4.39~1.85~0.17~0~2~12~10;
  graphprt("-c=1 -cf=cpm45.ps");
  xy(Risk,exReturn);

